## mingw-w64-waf-2.1.8-1.src.tar.zst

=== build_system_kit/nostate/wscript ===
#! /usr/bin/env python
# encoding: utf-8
# Thomas Nagy, 2010 (ita)

"""
See README.txt
"""

def build(bld):
	bld.program(source='main.c', target='app', use='mylib', cflags=['-O2'])
	bld.stlib(source='a.c', target='mylib')
