=== demos/perl/wscript ===
#! /usr/bin/env python
# encoding: utf-8
# anonymous coward, 2007
# Thomas Nagy, 2010

VERSION='0.0.1'
APPNAME='perl_test'

top = '.'
out = 'build'

def options(opt):
	opt.load('compiler_c')
	opt.load('perl')

def configure(conf):
	conf.load('compiler_c')
	conf.load('perl')

	# check for perl
	conf.check_perl_version((5,6,0))

	conf.check_perl_ext_devel()

	# check for some perl module...
	conf.check_perl_module('Cairo')
	# ...and a specific version
	conf.check_perl_module('Devel::PPPort 4.89')

def build(bld):

	# a perl extension module
	bld(
		features     = 'c cshlib perlext',
		source       = 'Mytest.xs',
		target       = 'Mytest',
		install_path = '${ARCHDIR_PERL}/auto')

	bld.install_files('${ARCHDIR_PERL}', 'Mytest.pm')
